# coding:utf-8
import threading
import time

from lib.service.StreamH264 import StreamH264


class H264PresureTest():

    def __init__(self):
        self.mobileStart = 100000000000                           # 开始手机号
        self.channel = 1                                          # 频道号
        self.terNum = 2                                           # 要压力测试的线程数
        self.videoPath = "../../h264/bbb3.h264"                   # 要推流的视频路劲
        self.audioPath = "../../h264/bbb3.aac"                    # 要推流的音频路劲
        self.host = "10.100.12.3"
        self.port = 1078

        self.threadInfo = {}                                      # 存放线程集
        self.threadInfo["threadObj"] = {}
        self.threadInfo["sucessT"] = {}
        self.threadInfo["failT"] = {}

    def setTerNum(self,data):
        self.terNum = data
    def setMobileStart(self,data="10000000000"):
        self.mobileStart = data
    def setChannel(self,data):
        self.channel = data
    def setVideoPath(self,data):
        self.videoPath = data
    def setAudioPath(self,data):
        self.audioPath = data
    def setHost(self,data):
        self.host = data
    def setPort(self,data):
        self.port = data

    def testService(self,cloudMirror):
        cloudMirror.sendAVStream()

    def run(self,mobile,threadId):
        cloudMirror = StreamH264()
        cloudMirror.setHost(self.host)
        cloudMirror.setPort(self.port)
        cloudMirror.connectServer()
        cloudMirror.setFPSVideo(30)
        cloudMirror.setFPSAudio(47)
        cloudMirror.setSendDur(0)
        cloudMirror.setVideoPath(self.videoPath)
        cloudMirror.setAudioPath(self.audioPath)
        cloudMirror.setMobile(mobile)
        cloudMirror.setChannel(self.channel)

        conThread = threading.Thread(target=self.testService,args=(cloudMirror,))
        self.threadInfo["threadObj"][threadId] = conThread
        conThread.start()
        print(threadId + "启动了：" + mobile + "-" + str(self.channel))

    def start(self):
        for i in range(0,self.terNum):
            mobile = self.mobileStart + i
            mobile = "0" + str(mobile)
            threadId = "threadId__" + str(i)
            self.run(mobile,threadId)
            time.sleep(0.1)

if __name__ == "__main__":
    test = H264PresureTest()
    test.setHost("10.100.12.3")
    test.setPort(1078)
    test.setMobileStart(10000000000)
    test.setChannel(1)
    test.setTerNum(20)
    test.setVideoPath("../../h264/bbb3.h264")
    test.setAudioPath("../../aac/bbb3.aac")
    test.start()